#define PRICE_TYPE_BUY	0
#define PRICE_TYPE_SELL	1

#event_handler("NextDay","StoreDayUpdateStart");
#event_handler("EvStoreDayUpdate","StoreDayUpdate");

// not needed now 05-05-12 ref rStoreTown; // NK 05-04-15 so we don't recalc each time

// change object to ref ( why object??? ) NK 05-05-12
void SetStoreGoods(ref _refStore,int _Goods,int _Quantity)
{
	string tmpstr = Goods[_Goods].name;
	_refStore.Goods.(tmpstr).Quantity = _Quantity;
}

void AddStoreGoods(ref _refStore,int _Goods,int _Quantity)
{
	aref refGoods;
	string tmpstr = Goods[_Goods].name;
	makearef(refGoods,_refStore.Goods.(tmpstr));
	int q = 0;
	if( CheckAttribute(refGoods,"Quantity") ) {q = sti(refGoods.Quantity);}
	refGoods.Quantity = q +_Quantity;
}

void RemoveStoreGoods(ref _refStore,int _Goods,int _Quantity)
{
	aref refGoods;
	string tmpstr = Goods[_Goods].name;
	makearef(refGoods,_refStore.Goods.(tmpstr));
	int q = 0;
	if( CheckAttribute(refGoods,"Quantity") ) q = sti(refGoods.Quantity);
	if(q<_Quantity) {refGoods.Quantity = 0;}
	else {refGoods.Quantity = q - _Quantity;}
}

int GetStoreGoodsQuantity(ref _refStore,int _Goods)
{
	string tmpstr = Goods[_Goods].name;
	int q = 0;
	if( CheckAttribute(_refStore,"Goods."+tmpstr) )
	{
		q = sti(_refStore.Goods.(tmpstr).Quantity);
	}
	return q;
}

// NK -->
int GetGoodPriceByType(ref refStore, ref char, int iGoodType, int quantity, int PriceType)
{
	//if(!TestRef(rStoreTown) || !CheckAttribute(rStoreTown,"size")) rStoreTown = GetCurrentTown();
	int unitSize = sti(Goods[iGoodType].Units);
	int i = iGoodType;
	bool tmpbooltn = false;
	string tname = GetTownIDFromGroup(refStore.group);
	int tsize = GetTownSize(tname);
	//if(CheckAttribute(rStoreTown,"id") && rStoreTown.id == tname) tmpbooltn = true;
	//if(!tmpbooltn)
	//{
		//rStoreTown = GetTownFromID(tname);
		//if(!CheckAttribute(rStoreTown,"size")) { trace("town " +tname + ", " + rStoreTown.name + " has no size!"); tsize = DEFAULT_TOWN_POP; }
		//else { tsize = sti(rStoreTown.size); } // assign the aref up here. NK 05-04-15
	//}
	//temp so it doesn't get so slow.
	// TIH added gunpowder here, as it KILLS the game with high quantitys! Jul20'06
	if( i==GOOD_BALLS || i==GOOD_GRAPES || i==GOOD_KNIPPELS || i==GOOD_BOMBS || i==GOOD_GUNPOWDER )
	{
		return makeint((quantity*GetStoreGoodsPrice(&refStore, iGoodType, PriceType, &char, 0) + unitSize-1) / unitSize);
	}
	//start normal good price find loop
	// sped up 05-04-15 NK
	//int oQty = GetStoreGoodsQuantity(refStore, iGoodType); // find orig qty.
	int price = 0;
	int mult = 1;
	if(PriceType == PRICE_TYPE_BUY) mult = -1;
	// new 05-04-15 -->
	string tmpstr = Goods[iGoodType].name;
	int gqty = refStore.Goods.(tmpstr).Quantity;
	if(gqty > 2 * quantity && gqty > tsize/4 ) // i.e. number is big enough we can do averages
	{
		price =  (GetStoreGoodsPrice(&refStore, iGoodType, PriceType, &char, 0) + GetStoreGoodsPrice(&refStore, iGoodType, PriceType, &char, mult * quantity)) / 2 * quantity;
	}
	else
	{
		for(i = 0; i < quantity; i++)
		{
			price += GetStoreGoodsPrice(&refStore, iGoodType, PriceType, &char, i);
		}
	}
	int sumPrice = (price + unitSize-1) / unitSize;
	return sumPrice;
}

// NK 05-04-15 PLEASE DON'T USE THIS FUNCTION. IT'S SLOW!
int GetGoodQuantityByPrice(ref refStore, ref char, int iGoodType, int sumPrice, int PriceType)
{
	//if(GetTownIDFromGroup(refStore.group) != "") { rStoreTown = GetTownFromID(GetTownIDFromGroup(refStore.group)); } // NK 05-04-15 set store's town aref.
	int unitSize = sti(Goods[iGoodType].Units);
	int i = 0;
	int curprice = 0;
	//int oQty = GetStoreGoodsQuantity(refStore, iGoodType); // find orig qty.
	sumPrice *= unitSize;
	/*int mult = 1;
	if(PriceType == PRICE_TYPE_BUY) mult = -1;*/
	while(curprice < sumPrice)
	{
		curprice += GetStoreGoodsPrice(&refStore, iGoodType, PriceType, &char, i);
		i++;
	}
	if(curprice > sumPrice) i--;
	i = i / unitSize;
	return i;
}

// NK <--

// 05-05-12 no longer needed. MUST SET rStoreTown FIRST, BEFORE CALLING THIS!
int GetStoreGoodsPrice(ref _refStore,int _Goods,int _PriceType,ref chref, int offset)
{
	float tradeModify;
	//If Captured all prices are 0
	if (LAi_IsCapturedLocation) return 0; // KK
	//Check which good we are handeling
	aref refGoods;
	string goodname = Goods[_Goods].name;
	makearef(refGoods,_refStore.Goods.(goodname));
	//If good doesn't exist return 0
	if( !CheckAttribute(_refStore,"Goods."+goodname) ) return 0;
	//Get some info about the town
	string town = GetTownIDFromGroup(_refStore.group); // KK
	int tsize = GetTownSize(GetTownIDFromGroup(_refStore.group));
	//Get info about the character
	int _TradeSkill = GetSummonSkillFromName(chref,SKILL_COMMERCE);
	//Get info about the good
	int basePrice = MakeInt(Goods[_Goods].Cost);
 	int tradeType = MakeInt(refGoods.TradeType);
	int gqty = makeint(refGoods.Quantity) + offset; // NK
	if(gqty==0) { gqty = 1; }//MAXIMUS [fix "divide by zero"]
	//Calculate the quantity modifier
	float qtyModify = makefloat(tsize) / makefloat(gqty);
	qtyModify = pow2(qtyModify, GQTY_PRICECHG_POW);
	qtyModify = fclamp(GQTY_PRICE_MINSCL, GQTY_PRICE_MAXSCL, qtyModify); // NK 05-04-15 to clamp qty modifier.
	//Calculate the discount
	float discount = (0.1 * GetTownCrewMorale(town) / (MORALE_MAX - MORALE_MIN)) * makefloat(GetTownNation(town) == PERSONAL_NATION); // KK
	//Calculate the skill multiplier
	float skillModify = GetCharPriceMod(&chref, _PriceType, true); // NK now use central func 05-04-19
	//Calculate the tradetype multiplier
	switch(tradeType)
	{
		case TRADE_TYPE_NORMAL:
			tradeModify=1+stf(refGoods.RndPriceModify);
		break;
		case TRADE_TYPE_EXPORT:
			tradeModify=0.7+stf(refGoods.RndPriceModify);
		break;
		case TRADE_TYPE_EXTRAEXPORT:
			tradeModify=0.0+stf(refGoods.RndPriceModify);
		break;
		case TRADE_TYPE_EXHAUSTED:
			//Make prices 0 when exhausted
			tradeModify=0;
			discount=0;
		break;
		case TRADE_TYPE_IMPORT:
			tradeModify=1.4+stf(refGoods.RndPriceModify);
		break;
		case TRADE_TYPE_CONTRABAND:
			qtyModify *= GQTY_CONTRABAND_PRICE_SCALAR;
			if( _PriceType == PRICE_TYPE_BUY)
			{
				tradeModify = 1.4 + stf(refGoods.RndPriceModify);
			}
			else
			{
				tradeModify = 0.6 + stf(refGoods.RndPriceModify);
			}
		break;
		case TRADE_TYPE_AMMUNITION:
			basePrice -= makeint(basePrice * discount);
			tradeModify = 0.6+stf(refGoods.RndPriceModify);
		break;
	}
	return MakeInt(basePrice*tradeModify*skillModify * qtyModify - discount); // KK
}

string GetStoreGoodsType(ref _refStore,int _Goods)
{
	string tmpstr = Goods[_Goods].name;
	int tradeType = TRADE_TYPE_NORMAL;
	if( CheckAttribute(_refStore,"Goods."+tmpstr) ) {
		tradeType = sti(_refStore.Goods.(tmpstr).TradeType);
	}
	//Moved to seperate function by Levis
	string name = GetTradeTypeName(tradeType);
	return name;
}

bool GetStoreGoodsUsed(ref _refStore,int _Goods)
{
	string tmpstr = Goods[_Goods].name;
	if( !CheckAttribute(_refStore,"Goods."+tmpstr) ) return false;
	if( sti(_refStore.Goods.(tmpstr).NotUsed)==true ) return false;
	if (sti(_refStore.Goods.(tmpstr).TradeType) == TRADE_TYPE_CONTRABAND) {
		if (!CheckOfficersPerk(GetMainCharacter(),"Trustworthy") && !LAi_IsCapturedLocation && GetTownNation(GetTownIDFromGroup(_refStore.group)) != PERSONAL_NATION) return false; // KK
	}

	// KNB - Check NoTrade flag for goods.
	if( CheckAttribute(Goods[_Goods],"NoTrade") && Goods[_Goods].NoTrade == true) return false;

	return true;
}

void SetStoresTradeUsed(int StoreNum,int GoodsNum,bool goodsUsed)
{
	string tmpstr = Goods[GoodsNum].Name;
	Stores[StoreNum].Goods.(tmpstr).NotUsed = !goodsUsed;
}

int storeDayUpdateCnt = -1;
void StoreDayUpdateStart()
{
	//trace("Gauging: NEXTDAY_store updates start");
	if(storeDayUpdateCnt >= 0) return;
	storeDayUpdateCnt = 0;
	PostEvent("EvStoreDayUpdate", 30);
}
void StoreDayUpdate()
{
	if(storeDayUpdateCnt >= 0)
	{
		UpdateStore(&Stores[storeDayUpdateCnt]);
		storeDayUpdateCnt++;
		if(storeDayUpdateCnt >= STORE_QUANTITY) storeDayUpdateCnt = -1;
		PostEvent("EvStoreDayUpdate", 30);
	}
	//else trace("Gauging: NEXTDAY_store updates end");
}

void UpdateStore(ref pStore)
{
	//Update the Import/Export
	UpdateTownImportExport(pStore, False); //Levis
	
	bool bigSize = pStore.StoreSize=="large";
	aref gref, curref;
	makearef(gref,pStore.Goods);
	int nq = GetAttributesNum(gref);
	int n;
	string tmpstr;
	// NK -->
	int tsize = DEFAULT_TOWN_POP;
	bool pirtown = false;
	//string logstr = "";
	//if(GetTownIDFromGroup(pStore.group) != "")
	//{
		tsize = GetTownSize(GetTownIDFromGroup(pStore.group));
		pirtown = GetTownNation(GetTownIDFromGroup(pStore.group)) == PIRATE;
		//Log_SetStringToLog("Store " + pStore.group + " of town " +  GetTownIDFromGroup(pStore.group) + " (pop " + tsize + ")");
	//}
	// NK <--
	for(int i=0; i<GOODS_QUANTITY; i++)
	{
		tmpstr = Goods[i].name;
		if( !CheckAttribute(gref,tmpstr) ) continue;
		makearef(curref,gref.(tmpstr));
		if( sti(curref.TradeType)==TRADE_TYPE_AMMUNITION ) {
			// NK -->
			//curref.Quantity = 1000+Rand(50)*20;
			n = sti(curref.Quantity) / sti(goods[i].Units);
			if(n < TT_AMMO_SCALE * GQTY_MAX_SCALAR * tsize * (1 + pirtown)) n += GetProductGoods(TRADE_TYPE_NORMAL,tsize * (1 + pirtown)) / TT_NORMAL_SCALE * TT_AMMO_SCALE;
			n *= sti(goods[i].Units);
			curref.Quantity = n;
			continue;
		}
		/*if( i==GOOD_SAILCLOTH || i==GOOD_PLANKS ) {
			curref.Quantity = 600+Rand(100);
			continue;
		}*/
		n = sti(curref.Quantity);
		//Added by Levis to fix Exhausted
		if( sti(curref.TradeType)==TRADE_TYPE_EXHAUSTED ) n = 0;
		if(i == GOOD_WHEAT)
		{
			//logstr = "Wheat at " + GetTownIDFromGroup(pStore.group) + " is ";
			if(n < tsize * MIN_FOOD_SCALAR)
			{
				n += GetProductGoods(sti(curref.TradeType),tsize);
				n += (tsize * FOOD_PER_CREW / 2);
				//logstr += "less than min.";
			}
			else
			{
				n -= GetConsumeGoods(sti(curref.TradeType),tsize);
				n += (tsize * FOOD_PER_CREW / 2);
				//logstr = "greater than min";
				if(n < tsize * MAX_FOOD_SCALAR)
				{
					//logstr += " and less than max.";
					n += GetProductGoods(sti(curref.TradeType),tsize);
				}
				else
				{
					//logstr += " and greater than max.";
					n -= GetConsumeGoods(TRADE_TYPE_EXPORT,tsize);
				}
			}
			//logstr += " Change " + (n - sti(curref.Quantity)) + ".";
			//Log_SetStringToLog(logstr);
		}
		else
		{
			if(n > tsize * GQTY_HIGH_SCALAR * GetTTScale(sti(curref.TradeType))) n -= GetConsumeGoods(sti(curref.TradeType),tsize);
			if(n < tsize * GQTY_LOW_SCALAR * GetTTScale(sti(curref.TradeType))) n += GetProductGoods(sti(curref.TradeType),tsize);
			if(n > tsize * GQTY_SEMIHIGH_SCALAR * GetTTScale(sti(curref.TradeType))) n -= GetConsumeGoods(sti(curref.TradeType),tsize)*0.5;
			if(n < tsize * GQTY_SEMILOW_SCALAR * GetTTScale(sti(curref.TradeType))) n += GetProductGoods(sti(curref.TradeType),tsize)*0.5;
			if(n > tsize * GQTY_MIN_SCALAR * GetTTScale(sti(curref.TradeType))) n -= GetConsumeGoods(sti(curref.TradeType),tsize);
			if(n < tsize * GQTY_MAX_SCALAR * GetTTScale(sti(curref.TradeType))) n += GetProductGoods(sti(curref.TradeType),tsize);
		}
		if(n<0) n=0;
		// NK <--
		curref.RndPriceModify = AddPriceModify(stf(curref.RndPriceModify),sti(curref.TradeType));
		curref.Quantity = n;
	}
}

float AddPriceModify(float curModify, int tradeType)
{
	float fMaxModify = 0.39;
	if(tradeType==TRADE_TYPE_CONTRABAND) fMaxModify = 0.99;
	if(curModify>0.01)
	{
		if(curModify<fMaxModify)	curModify += 0.01 - 0.02*frnd();
		else	curModify -= 0.01*frnd();
	}
	else	curModify += 0.01*frnd();
	return curModify;
}

// NK -->
float GetTTScale(int tradeType)
{
	switch(tradeType)
	{
		case TRADE_TYPE_NORMAL:			return  TT_NORMAL_SCALE;		break;
		case TRADE_TYPE_EXPORT:			return  TT_EXPORT_SCALE;		break;
		case TRADE_TYPE_IMPORT:			return  TT_IMPORT_SCALE;		break;
		case TRADE_TYPE_CONTRABAND: 	return  TT_CONTRABAND_SCALE;	break;
		case TRADE_TYPE_EXHAUSTED: 		return  TT_EXHAUSTED_SCALE;		break;
		case TRADE_TYPE_EXTRAEXPORT:	return  TT_EXTRAEXPORT_SCALE;	break;
	}
	return TT_NORMAL_SCALE;
}
int GetProductGoods(int tradeType, int size)
{
	float retnum = makefloat(size)/10.0*(1.0 - GQTY_VARIANCE + frand(GQTY_VARIANCE*2.0));
	/*switch(tradeType)
	{
		case TRADE_TYPE_NORMAL:		retnum *= TT_NORMAL_SCALE;	break;
		case TRADE_TYPE_EXPORT:		retnum *= TT_EXPORT_SCALE;	break;
		case TRADE_TYPE_IMPORT:		retnum *= TT_IMPORT_SCALE;	break;
		case TRADE_TYPE_CONTRABAND: retnum *= TT_CONTRABAND_SCALE;	break;
	}*/
	//Use the GetTTScale -Levis
	retnum *= GetTTScale(tradeType);
	return makeint(retnum);
}

int GetConsumeGoods(int tradeType, int size)
{
	float retnum = makefloat(size)/10.0*(1.0 - GQTY_VARIANCE + frand(GQTY_VARIANCE*2.0));
	/*switch(tradeType)
	{
		case TRADE_TYPE_NORMAL: 	retnum *= TT_NORMAL_SCALE;	break;
		case TRADE_TYPE_EXPORT: 	retnum *= TT_EXPORT_SCALE;	break;
		case TRADE_TYPE_IMPORT: 	retnum *= TT_IMPORT_SCALE; break;
		case TRADE_TYPE_CONTRABAND: retnum *= TT_CONTRABAND_SCALE; break;
	}*/
	//Use the GetTTScale -Levis
	retnum *= GetTTScale(tradeType);
	return makeint(retnum);
}
// NK <--

// KK -->
int GetStoreOwnerIndex(int store_no)
{
	if (store_no < 0 || store_no >= STORE_QUANTITY) return -1;
	if (!CheckAttribute(&Stores[store_no], "owner")) return -1;
	return GetCharacterIndex(Stores[store_no].owner);
}
// <-- KK

//Levis -->
string GetTradeTypeName(int tradeType)
{
	//This function returns the trade type name for a given trade type.
	switch(tradeType)
	{
	case TRADE_TYPE_NORMAL:
		return TRADE_TYPE_NORMAL_NAME;
		break;
	case TRADE_TYPE_EXPORT:
		return TRADE_TYPE_EXPORT_NAME;
		break;
	case TRADE_TYPE_IMPORT:
		return TRADE_TYPE_IMPORT_NAME;
		break;
	case TRADE_TYPE_CONTRABAND:
		return TRADE_TYPE_CONTRABAND_NAME;
		break;
	case TRADE_TYPE_EXHAUSTED:
		return TRADE_TYPE_EXHAUSTED_NAME;
		break;
	case TRADE_TYPE_EXTRAEXPORT:
		return TRADE_TYPE_EXTRAEXPORT_NAME;
		break;
	case TRADE_TYPE_AMMUNITION:
		return TRADE_TYPE_AMMUNITION_NAME;
		break;
	}
	Trace("Missing trade type");
	return TRADE_TYPE_NORMAL_NAME;
}

int GetTradeTypeByName(string TradeName);
{
	//this function returns the trade type for a given trade type name
	int tt=TRADE_TYPE_NORMAL;
	switch(TradeName)
	{
	case TRADE_TYPE_EXPORT_NAME:		tt=TRADE_TYPE_EXPORT;		break;
	case TRADE_TYPE_IMPORT_NAME:		tt=TRADE_TYPE_IMPORT;		break;
	case TRADE_TYPE_CONTRABAND_NAME:	tt=TRADE_TYPE_CONTRABAND;	break;
	case TRADE_TYPE_EXHAUSTED_NAME:		tt=TRADE_TYPE_EXHAUSTED;	break;
	case TRADE_TYPE_EXTRAEXPORT_NAME:	tt=TRADE_TYPE_EXTRAEXPORT;	break;
	}
	return tt;
}

void SetGoodTradeType(ref ctown, int good, int tradetype)
{
	//Get the info we need
	ref island = GetIslandByID(ctown.island);
	ref refStore = GetTownStore(ctown.id);
	string ttname = GetTradeTypeName(tradetype);
	string goodname = Goods[good].name;
	string storename = refStore.Group;
	//Check if this good is already a tradetype
	string oldtradetypename = GetStoreGoodsType(refStore, good);
	int oldtradetype = GetTradeTypeByName(oldtradetypename);
	//If the good already has a tradetype remove it there
	if(oldtradetype != TRADE_TYPE_NORMAL) RemoveGoodFromIslandTradeType(ctown, good, oldtradetype);
	//Check if there are 6 of this type already, if so overwrite 1
	string id = "id1";
	if(CheckAttribute(island,"Trade."+storename+"."+ttname))
	{
		aref ttype;
		makearef(ttype,island.Trade.(storename).(ttname));
		int ngoods = GetAttributesNum(ttype);
		if(ngoods>5)
		{
			int rgood = rand(5)+1;
			id = "id"+rgood;
		}
	}
	//Set the good
	island.Trade.(storename).(ttname).(id) = good;
	//Set in store
	refStore.Goods.(goodName).TradeType = GetTradeTypeByName(ttname);
	UpdateStore(refStore);
}

void RemoveGoodFromIslandTradeType(ref ctown, int good, int oldtradetype)
{
	//This function removes a good from a given trade type
	//First get some relevant info
	ref island = GetIslandByID(ctown.island);
	ref refStore = GetTownStore(ctown.id);
	string storename = refStore.Group;
	string ttname = GetTradeTypeName(oldtradetype);
	aref ttype;
	makearef(ttype,island.Trade.(storename).(ttname));
	int ngoods = GetAttributesNum(ttype)+1;
	aref oldgoods;
	makearef(oldgoods,island.Trade.(storename).oldgoods);
	//Store the tradetypes in a temp ref and remove the real one
	CopyAttributes(oldgoods, ttype);
	DeleteAttribute(island,"Trade."+storename+"."+ttname);
	int shift = 0;
	string id = "id";
	//Loop trough all the trade types
	for(int i=1; i<ngoods; i++)
	{
		id = "id"+i;
		if(oldgoods.(id) == good)
		{
			//If the one which has to be removed is found dont add it and add a shift parameter so the id's are correct.
			shift = -1;
		}
		else
		{
			string newid = "id" + (i + shift);
			island.Trade.(storename).(ttname).(newid) = oldgoods.(id);
		}
	}
	//Delete the temp tradetype
	DeleteAttribute(island,"Trade.oldgoods");
	//Set in store//Set in store
	string goodName = Goods[good].Name;
	refStore.Goods.(goodName).TradeType = TRADE_TYPE_NORMAL;
	UpdateStore(refStore);
}
//Levis <--